



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>K-近邻</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">K-近邻</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-18 04:30:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>概述</strong></p>
<p>　　KNN算法本身简单有效，是一种lazy-learning算法；</p>
<p>　　分类器不需要使用训练集进行训练，训练时间复杂度为0；</p>
<p>　　KNN分类的计算复杂度和训练集中的文档数目成正比，也就是说，如果训练集中文档总数为n，那么KNN的分类时间复杂度为O(n)。</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1096247/201711/1096247-20171110092225028-275919899.png" /></p>
<p>　　如果K = 3，绿色圆点的最近的3个邻居是2个红色小三角形和1个蓝色小正方形，少数从属于多数，基于统计的方法，判定绿色的这个待分类点属于红色的三角形一类。</p>
<p>　　如果K = 5，绿色圆点的最近的5个邻居是2个红色三角形和3个蓝色的正方形，还是少数从属于多数，基于统计的方法，判定绿色的这个待分类点属于蓝色的正方形一类。</p>
<p><strong>对于未知类别属性数据集中的点</strong></p>
<p>　　1.计算已知类别数据集中的点与当前点的距离</p>
<p>　　2.按照距离一次排序</p>
<p>　　3.选取与当前点距离最小的K个点</p>
<p>　　4.确定前K个点所在类别的出现概率</p>
<p>　　5.返回前K个点出现频率最高的类别作为当前点预测分类</p>
<p><strong>三个基本要素　　</strong></p>
<p>　　K值的选择，距离度量和分类决策规则</p>
<p><strong>KNN在分类是主要的不足</strong></p>
<p>　　当样本不平衡时，如一个类的样本容量很大，而其他类样本容量很小时，有可能导致当输入一个新样本时，该样本的K个邻居中大容量类的样本占多数。不同的样本要给予不同权重项。</p>
<p><strong>超参数</strong></p>
<p>　　L1（Manhattan）distance</p>
<p>　　　　<img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1096247/201711/1096247-20171110093611669-1628660967.png" /></p>
<p>　　L2（Euclidean）distance</p>
<p>　　　　<img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1096247/201711/1096247-20171110093655981-1500629879.png" /></p>
<p><strong>交叉验证</strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1096247/201711/1096247-20171110093823669-1338871733.png" /></p>
<p><strong>K-近邻注意事项</strong></p>
<p><strong>　　</strong>1、选取超参数的正确方法是：将原始训练集分为训练集和验证集，我们在验证集上尝试不同的超参数，最后保留表现最好那个；</p>
<p>　　2、如果训练数据量不够，使用交叉验证方法，它能帮助我们在选取最有超参数的时候减少噪音；</p>
<p>　　3、一旦找到最优的超参数，就让算法以该参数在测试集跑且只跑一次，并根据测试结果评价算法；</p>
<p>　　4、最近邻分类器能够在CIFAR-10上得到将近40%的准确率。该算法简单易实现，但需要存储所有训练数据，并且在测试的时候过于耗费计算能力；</p>
<p>　　5、仅仅使用L1和L2范数来进行像素比较是不够的，图像更多的是按照背景和颜色被分类，而不是语义主题分类；</p>
<p>　　6、对数据进行预处理，对数据中的特征进行归一化（normalize），让其具有零平均值（zero mean）和单位方差（unit variance）；</p>
<p>　　7、如果数据是高维数据，考虑使用降维方法，比如PCA；</p>
<p>　　8、将数据随机分入训练集和验证集。按照一般规律，70%-90%数据作为训练集；</p>
<p>　　9、在验证集上调优，尝试足够多的k值，尝试L1和L2两种范数计算方式。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqd5d79d.html">ASP&period;Net MVC&mdash;&mdash;使用 ITextSharp 完美解决HTML转PDF（中文也可以）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o13peq.html">SQL Server Audit监控触发器状态</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql17n69.html">Unix哲学</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pkne78.html">MySQL主主复制&plus;MMM实现高可用</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyr3mj8.html">Bootstrap &amp;lt&semi;基础三十二&amp;gt&semi;模态框（Modal）插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4op2e8.html">VBS操作剪切板</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv42nzq.html">重构第10天：提取方法&lpar;Extract Method&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv66rj8.html">CustomerConfigHelper</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zrk4z9.html">记一次系统稳定性问题的分析处理过程（因CallContext使用不当而造成bug）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnyowrq.html">aJax提交&mdash;&mdash;服务端不能用request存储数据，session存数据客户端可以接收到</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok66x59.html">全世界最详细的一步一步搭建RAC步骤（一）---安装操作系统RHEL4&period;6【weber出品】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkdv4e8.html">C&plus;&plus;11改进我们的程序之简化我们的程序1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvvmyj8.html">2019&period;03&period;11 COGS2652 秘术（天文密葬法）（分数规划&plus;长链剖分）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7og1pk8.html">AYUI第12个作品-英雄联盟-魔法少女的星光水晶2&period;0-WPF版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/960nedn9.html">【BFS宽度优先搜索】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r7d648.html">JS实现继承的6种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk17vn8.html">MySQL 5&period;6表空间传输</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj2no7q.html">K8s集群安装和检查（经验分享）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx27v408.html">Spring Autowired原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn36kkq.html">TeamTalk 5</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qll3v06q.html">Linux服务器配置---安装nfs</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w23xgq.html">Web3&period;js API 中文文档</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4l3km9.html">mysql 2</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r6w4z8.html">SQL8数据库定期自动备份</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjvx409.html">js  迭代方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oyjg18.html">bind的封装</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rx0zm9.html">Jenkins实现SVN&plus;Maven&plus;Java项目的持续集成</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4lkej9.html">TNS-12537&comma;TNS-12560&comma;TNS-00507 Linux Error&colon; 29&colon; Illegal seek解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyj3rgq.html">windows下openssl编译</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25l14lq.html">11&colon; python递归</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
